//////////////////////////////////////////////////////////////////////////// 
// IPD - Image Processing Design Toolbox
//
// Copyright (c) by Dr. Eng. (J) Harald Galda, 2009 - 2010
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

global IPD_PATH;

global WAVELET_DAUBECHIES_2;

disp('global WAVELET_DAUBECHIES_2;');

disp('RGB = ReadImage(''small_teaset.png''); Image = RGB2Gray(RGB);');

disp('WaveletFrames = CreateWaveletFrames(Image, WAVELET_DAUBECHIES_2, 3);');

disp('ChannelVariance = ComputeChannelVariance(WaveletFrames, [9 9]);');

disp('ListOfTitles = [''Horizontal Detail on 1st Level''; ...');

disp('                ''Diagonal Detail on 1st Level''; ...');

disp('                ''Vertical Detail on 1st Level''; ...');

disp('                ''Horizontal Detail on 2nd Level''; ...');

disp('                ''Diagonal Detail on 2nd Level''; ...');

disp('                ''Vertical Detail on 2nd Level''; ...');

disp('                ''Horizontal Detail on 3rd Level''; ...');

disp('                ''Diagonal Detail on 3rd Level''; ...');

disp('                ''Vertical Detail on 3rd Level''; ...');

disp('                ''Approximation on 3rd Level''];');

disp('figure(); ShowImage(Image, ''Original Image'');');
                
disp('for n = 1 : size(ChannelVariance, 3)');

disp(' Image = ChannelVariance(:, :, n);');

disp(' figure(); ShowImage(Image / max(Image), ListOfTitles(n)); ');

disp('end;');

DemoPath = IPD_PATH + 'demos\';

RGB = ReadImage(DemoPath + 'small_teaset.png');

Image = RGB2Gray(RGB);

WaveletFrames = CreateWaveletFrames(Image, WAVELET_DAUBECHIES_2, 3);

ChannelVariance = ComputeChannelVariance(WaveletFrames, [9 9]);

ListOfTitles = ['Horizontal Detail on 1st Level'; ...
                'Diagonal Detail on 1st Level'; ...
                'Vertical Detail on 1st Level'; ...
                'Horizontal Detail on 2nd Level'; ...
                'Diagonal Detail on 2nd Level'; ...
                'Vertical Detail on 2nd Level'; ...
                'Horizontal Detail on 3rd Level'; ...
                'Diagonal Detail on 3rd Level'; ...
                'Vertical Detail on 3rd Level'; ...
                'Approximation on 3rd Level']; 
                
figure(); 
                
ShowImage(Image, 'Original Image');
                                
for n = 1 : size(ChannelVariance, 3)
  
 Image = ChannelVariance(:, :, n);
  
 figure();
  
 ShowImage(Image / max(Image), ListOfTitles(n));  
                  
end;

clear RGB;

clear Image;

clear WaveletFrames;

clear ChannelVariance;

clear ListOfTitles;
 