//////////////////////////////////////////////////////////////////////////// 
// IPD - Image Processing Design Toolbox
//
// Copyright (c) by Dr. Eng. (J) Harald Galda, 2009 - 2010
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
////////////////////////////////////////////////////////////////////////////

try
  
 link('cxcore200.dll');

 link('cv200.dll');

 link('highgui200.dll');

catch
  
 select getlanguage()
   
  case 'de_DE'
    
   Message = ['Fehler bei dem Versuch, eine Bibliothek zu laden, ' + ...
              'die für diese Toolbox notwendig ist.'; ...
              'Die folgenden Funktionen stehen nicht zur Verfügung:'];
    
  case 'en_US'
    
   Message = 'Error occured when trying to load a library required ' ...
           + 'by this toolbox.';
              
  case 'ja_JP'
    
    Message = '本ツールボックスは必要とするライブラリーをロードしてみたときに' ...
            + 'エラーが起こった。';
   
  else
    
   Message = 'Error occured when trying to load a library required ' ...
           + 'by this toolbox.';
              
 end;
 
 disp(Message);
 
 return;
 
end;

ListOfFunctions = ['CloseVideoFile'; ...
                   'ConvertColorSpace'; ...
                   'CreatePixelIndexList'; ...
                   'DistanceTransform'; ...
                   'GetVideoInfo'; ...
                   'MaskFilter'; ...
                   'MatchTemplate'; ...
                   'MedianFilter'; ...
                   'MorphologicalFilter'; ...
                   'OpenVideoFile'; ...
                   'ReadImageFile'; ...
                   'ReadImageFromVideo'; ...
                   'SearchBlobs'; ...
                   'SeparableFilter'; ... 
                   'VarianceFilter'; ...
                   'Watershed'; ...
                   'WriteImageFile'];
                   
addinter('libIPD.dll','libIPD', ListOfFunctions);
                   
clear ListOfFunctions;

